import "../chunks/chunk-U5RRZUYZ.js";

// src/core/Document.ts
import { metadata } from "alinea/input/metadata";
import { path } from "alinea/input/path";
import { tab, tabs } from "alinea/input/tabs";
import { text } from "alinea/input/text";
import { IcRoundInsertDriveFile } from "alinea/ui/icons/IcRoundInsertDriveFile";
import { IcRoundShare } from "alinea/ui/icons/IcRoundShare";
import { Meta } from "./Meta.js";
import { type } from "./Type.js";
function document(label, definition) {
  return type(label, {
    ...tabs(
      tab("Document", {
        title: text("Title", { width: 0.5 }),
        path: path("Path", { width: 0.5 }),
        ...definition,
        [Meta]: {
          icon: IcRoundInsertDriveFile
        }
      }),
      tab("Metadata", {
        metadata: metadata(),
        [Meta]: {
          icon: IcRoundShare
        }
      })
    ),
    [Meta]: definition[Meta]
  });
}
export {
  document
};
