import { EntryRow } from './EntryRow.js';
export declare const META_KEY = "@alinea";
export type EntryMeta = typeof EntryMeta.infer;
export declare const EntryMeta: import("cito").Type<{
    entryId: string;
    i18nId?: string | undefined;
    type: string;
    index: string;
    root?: string | undefined;
    seeded?: boolean | undefined;
}>;
export type EntryRecord = typeof EntryRecord.infer & {
    [field: string]: unknown;
};
export declare const EntryRecord: import("cito").Type<{
    title: string | undefined;
    "@alinea": {
        entryId: string;
        i18nId?: string | undefined;
        type: string;
        index: string;
        root?: string | undefined;
        seeded?: boolean | undefined;
    };
}>;
interface RequiredEntryFields extends Partial<EntryRow> {
    entryId: string;
    type: string;
    index: string;
    title: string;
    data: Record<string, any>;
}
export declare function createRecord(entry: RequiredEntryFields): EntryRecord;
export {};
