import { Mutation } from 'alinea/core/Mutation';
import { Field, FieldOptions } from './Field.js';
export interface FieldGetter {
    <Value>(field: Field<Value>): Value;
}
export interface OptionsTracker<Options = any> {
    (getter: FieldGetter): Partial<Options> | Promise<Partial<Options>>;
}
export interface ValueTracker<Value = any> {
    (getter: FieldGetter): Value;
}
export interface MutationTracker {
    (mutations: Array<Mutation>): Array<Mutation> | Promise<Array<Mutation>>;
}
export declare function optionTrackerOf(field: Field): OptionsTracker<any> | undefined;
export declare function valueTrackerOf(field: Field): ValueTracker<any> | undefined;
export declare namespace track {
    function options<Value, OnChange, Options extends FieldOptions<Value>>(field: Field<Value, OnChange, Options>, tracker: OptionsTracker<Options>): Field<Value, OnChange, Options>;
    function value<Value>(field: Field<Value>, tracker: ValueTracker<Value>): Field<Value>;
}
