import {
  connect
} from "../../chunks/chunk-LMUDRU2U.js";
import "../../chunks/chunk-FLZ4KUMA.js";
import "../../chunks/chunk-4JLFL6LD.js";
import "../../chunks/chunk-U5RRZUYZ.js";

// src/core/driver/TestDriver.ts
import sqlite from "@alinea/sqlite-wasm";
import { Database, Handler, JWTPreviews } from "alinea/backend";
import { Logger } from "../util/Logger.js";
import { DefaultDriver } from "./DefaultDriver.js";
var TestDriver = class extends DefaultDriver {
  store = sqlite().then(
    ({ Database: Database2 }) => connect(new Database2()).toAsync()
  );
  db = this.store.then(async (store) => {
    const db = new Database(this.config, store);
    await db.fill({ async *entries() {
    } }, "");
    return db;
  });
  handler = this.db.then(async (db) => {
    const handler = new Handler({
      config: this.config,
      db,
      previews: new JWTPreviews("test"),
      previewAuthToken: "test"
    });
    return handler.connect({ logger: new Logger("test") });
  });
  async exportStore(outDir, data) {
  }
  async readStore() {
    return this.store;
  }
  async connection() {
    return this.handler;
  }
  async resolver() {
    return this.handler;
  }
};
function createTestCMS(config) {
  return new TestDriver(config);
}
export {
  createTestCMS
};
