import * as config from './MediaSchema.js';
export type MediaLibrary = config.MediaLibrary;
export declare const MediaLibrary: typeof config.MediaLibrary;
export type MediaFile = config.MediaFile;
export declare const MediaFile: typeof config.MediaFile;
export declare const MediaSchema: {
    MediaLibrary: import("alinea/core").Type<{
        title: import("../../input/text.js").TextField;
        path: import("../../input/path.js").PathField;
    }>;
    MediaFile: import("alinea/core").Type<{
        title: import("../../input/text.js").TextField;
        path: import("../../input/path.js").PathField;
        location: import("../../input/hidden.js").HiddenField<string>;
        extension: import("../../input/hidden.js").HiddenField<string>;
        size: import("../../input/hidden.js").HiddenField<number>;
        hash: import("../../input/hidden.js").HiddenField<string>;
        width: import("../../input/hidden.js").HiddenField<number>;
        height: import("../../input/hidden.js").HiddenField<number>;
        preview: import("../../input/hidden.js").HiddenField<string>;
        averageColor: import("../../input/hidden.js").HiddenField<string>;
        focus: import("../../input/hidden.js").HiddenField<{
            x: number;
            y: number;
        }>;
        thumbHash: import("../../input/hidden.js").HiddenField<string>;
    }>;
};
