import "../../chunks/chunk-U5RRZUYZ.js";

// src/core/media/MediaSchema.browser.tsx
import { type } from "alinea/core";
import { IcRoundPermMedia } from "alinea/ui/icons/IcRoundPermMedia";
import { MediaExplorer } from "../../dashboard/view/MediaExplorer.js";
import { FileEntry } from "../../dashboard/view/media/FileEntry.js";
import {
  FileSummaryRow,
  FileSummaryThumb
} from "../../dashboard/view/media/FileSummary.js";
import { Meta } from "../Meta.js";
import * as config from "./MediaSchema.js";
var MediaLibrary2 = type(
  "Media directory",
  {
    ...config.MediaLibrary,
    [Meta]: {
      isContainer: true,
      contains: ["MediaLibrary"],
      view: MediaExplorer,
      icon: IcRoundPermMedia
    }
  }
);
var MediaFile2 = type("File", {
  ...config.MediaFile,
  [Meta]: {
    isHidden: true,
    summaryRow: FileSummaryRow,
    summaryThumb: FileSummaryThumb,
    view: FileEntry
  }
});
var MediaSchema = {
  MediaLibrary: MediaLibrary2,
  MediaFile: MediaFile2
};
export {
  MediaFile2 as MediaFile,
  MediaLibrary2 as MediaLibrary,
  MediaSchema
};
