/// <reference types="react" />
import { Route, Router } from './atoms/RouterAtoms.js';
export declare const entryRoute: Route<{
    editor: {
        transition: import("jotai").PrimitiveAtom<{
            transition: import("./atoms/EntryEditorAtoms.js").EntryTransition;
            done: Promise<any>;
        } | undefined> & {
            init: {
                transition: import("./atoms/EntryEditorAtoms.js").EntryTransition;
                done: Promise<any>;
            } | undefined;
        };
        revisionId: string;
        activePhase: import("../core.js").EntryPhase;
        phaseInUrl: import("jotai").Atom<import("../core.js").EntryPhase | undefined>;
        selectedPhase: import("jotai").Atom<import("../core.js").EntryPhase>;
        entryData: import("./atoms/EntryEditorAtoms.js").EntryData;
        editMode: import("jotai").PrimitiveAtom<import("./atoms/EntryEditorAtoms.js").EditMode> & {
            init: import("./atoms/EntryEditorAtoms.js").EditMode;
        };
        activeVersion: import("./atoms/EntryEditorAtoms.js").Version;
        type: import("../core.js").Type;
        yUpdate: import("jotai").Atom<Uint8Array>;
        activeTitle: import("jotai").Atom<string>;
        hasChanges: import("jotai").PrimitiveAtom<boolean> & {
            init: boolean;
        };
        draftEntry: import("jotai").Atom<Promise<import("../core.js").EntryRow>>;
        saveDraft: import("jotai").WritableAtom<null, [], Promise<void>> & {
            init: null;
        };
        publishEdits: import("jotai").WritableAtom<null, [], Promise<void>> & {
            init: null;
        };
        restoreRevision: import("jotai").WritableAtom<null, [], Promise<void>> & {
            init: null;
        };
        publishDraft: import("jotai").WritableAtom<null, [], Promise<void>> & {
            init: null;
        };
        discardDraft: import("jotai").WritableAtom<null, [], Promise<void>> & {
            init: null;
        };
        archivePublished: import("jotai").WritableAtom<null, [], Promise<void>> & {
            init: null;
        };
        publishArchived: import("jotai").WritableAtom<null, [], Promise<void>> & {
            init: null;
        };
        deleteFile: import("jotai").WritableAtom<null, [], Promise<void> | undefined> & {
            init: null;
        };
        deleteArchived: import("jotai").WritableAtom<null, [], Promise<void>> & {
            init: null;
        };
        saveTranslation: import("jotai").WritableAtom<null, [locale: string], Promise<void>> & {
            init: null;
        };
        discardEdits: import("jotai").WritableAtom<null, [], void> & {
            init: null;
        };
        isLoading: import("jotai").Atom<boolean>;
        showHistory: import("jotai").WritableAtom<boolean, [value: boolean], void>;
        revisionsAtom: import("jotai").Atom<Promise<import("../backend/History.js").Revision[]>>;
        previewRevision: import("jotai").PrimitiveAtom<{
            ref: string;
            file: string;
        } | undefined> & {
            init: {
                ref: string;
                file: string;
            } | undefined;
        };
        form: import("jotai").Atom<import("./atoms/FormAtoms.js").FormAtoms<object>>;
        view: import("react").ComponentType<import("./view/EntryEdit.js").EntryEditProps> | undefined;
        parents: {
            entryId: string;
            path: string;
        }[];
        client: import("../core.js").Connection;
        config: import("../core.js").Config;
        entryId: string;
        versions: import("./atoms/EntryEditorAtoms.js").Version[];
        phases: Record<import("../core.js").EntryPhase, import("./atoms/EntryEditorAtoms.js").Version>;
        availablePhases: import("../core.js").EntryPhase[];
        translations: {
            locale: string;
            entryId: string;
        }[];
        parentNeedsTranslation: boolean;
        previewToken: string;
        edits: import("./atoms/Edits.js").Edits;
    } | undefined;
}>;
export declare const draftRoute: Route<{
    editor: {
        transition: import("jotai").PrimitiveAtom<{
            transition: import("./atoms/EntryEditorAtoms.js").EntryTransition;
            done: Promise<any>;
        } | undefined> & {
            init: {
                transition: import("./atoms/EntryEditorAtoms.js").EntryTransition;
                done: Promise<any>;
            } | undefined;
        };
        revisionId: string;
        activePhase: import("../core.js").EntryPhase;
        phaseInUrl: import("jotai").Atom<import("../core.js").EntryPhase | undefined>;
        selectedPhase: import("jotai").Atom<import("../core.js").EntryPhase>;
        entryData: import("./atoms/EntryEditorAtoms.js").EntryData;
        editMode: import("jotai").PrimitiveAtom<import("./atoms/EntryEditorAtoms.js").EditMode> & {
            init: import("./atoms/EntryEditorAtoms.js").EditMode;
        };
        activeVersion: import("./atoms/EntryEditorAtoms.js").Version;
        type: import("../core.js").Type;
        yUpdate: import("jotai").Atom<Uint8Array>;
        activeTitle: import("jotai").Atom<string>;
        hasChanges: import("jotai").PrimitiveAtom<boolean> & {
            init: boolean;
        };
        draftEntry: import("jotai").Atom<Promise<import("../core.js").EntryRow>>;
        saveDraft: import("jotai").WritableAtom<null, [], Promise<void>> & {
            init: null;
        };
        publishEdits: import("jotai").WritableAtom<null, [], Promise<void>> & {
            init: null;
        };
        restoreRevision: import("jotai").WritableAtom<null, [], Promise<void>> & {
            init: null;
        };
        publishDraft: import("jotai").WritableAtom<null, [], Promise<void>> & {
            init: null;
        };
        discardDraft: import("jotai").WritableAtom<null, [], Promise<void>> & {
            init: null;
        };
        archivePublished: import("jotai").WritableAtom<null, [], Promise<void>> & {
            init: null;
        };
        publishArchived: import("jotai").WritableAtom<null, [], Promise<void>> & {
            init: null;
        };
        deleteFile: import("jotai").WritableAtom<null, [], Promise<void> | undefined> & {
            init: null;
        };
        deleteArchived: import("jotai").WritableAtom<null, [], Promise<void>> & {
            init: null;
        };
        saveTranslation: import("jotai").WritableAtom<null, [locale: string], Promise<void>> & {
            init: null;
        };
        discardEdits: import("jotai").WritableAtom<null, [], void> & {
            init: null;
        };
        isLoading: import("jotai").Atom<boolean>;
        showHistory: import("jotai").WritableAtom<boolean, [value: boolean], void>;
        revisionsAtom: import("jotai").Atom<Promise<import("../backend/History.js").Revision[]>>;
        previewRevision: import("jotai").PrimitiveAtom<{
            ref: string;
            file: string;
        } | undefined> & {
            init: {
                ref: string;
                file: string;
            } | undefined;
        };
        form: import("jotai").Atom<import("./atoms/FormAtoms.js").FormAtoms<object>>;
        view: import("react").ComponentType<import("./view/EntryEdit.js").EntryEditProps> | undefined;
        parents: {
            entryId: string;
            path: string;
        }[];
        client: import("../core.js").Connection;
        config: import("../core.js").Config;
        entryId: string;
        versions: import("./atoms/EntryEditorAtoms.js").Version[];
        phases: Record<import("../core.js").EntryPhase, import("./atoms/EntryEditorAtoms.js").Version>;
        availablePhases: import("../core.js").EntryPhase[];
        translations: {
            locale: string;
            entryId: string;
        }[];
        parentNeedsTranslation: boolean;
        previewToken: string;
        edits: import("./atoms/Edits.js").Edits;
    } | undefined;
}>;
export declare const router: Router;
