import { Label } from 'alinea/core/Label';
import { ComponentType, PropsWithChildren } from 'react';
export type LabelHeaderProps = {
    label: Label;
    help?: string;
    optional?: boolean;
    size?: 'small' | 'medium' | 'large';
    focused?: boolean;
    icon?: ComponentType;
    shared?: boolean;
};
export declare const LabelHeader: import("react").NamedExoticComponent<LabelHeaderProps>;
export type LabelProps = PropsWithChildren<{
    label?: Label;
    asLabel?: boolean;
    help?: string;
    optional?: boolean;
    width?: number;
    inline?: boolean;
    collection?: boolean;
    focused?: boolean;
    size?: 'small' | 'medium' | 'large';
    icon?: ComponentType;
    empty?: boolean;
    shared?: boolean;
}>;
/** Label for an input */
export declare const InputLabel: import("react").ForwardRefExoticComponent<{
    label?: string | undefined;
    asLabel?: boolean | undefined;
    help?: string | undefined;
    optional?: boolean | undefined;
    width?: number | undefined;
    inline?: boolean | undefined;
    collection?: boolean | undefined;
    focused?: boolean | undefined;
    size?: "small" | "medium" | "large" | undefined;
    icon?: ComponentType | undefined;
    empty?: boolean | undefined;
    shared?: boolean | undefined;
} & {
    children?: import("react").ReactNode;
} & import("react").RefAttributes<HTMLElement>>;
