import "../../chunks/chunk-U5RRZUYZ.js";

// src/input/metadata/MetadataField.tsx
import { Type, type } from "alinea/core";
import { RecordField } from "alinea/core/field/RecordField";
import { link } from "alinea/input/link";
import { object } from "alinea/input/object";
import { text } from "alinea/input/text";
var MetadataField = class extends RecordField {
};
function metadata(label = "Metadata", options = {}) {
  const fields = type("Fields", {
    title: text("Title", { width: 0.5 }),
    description: text("Description", { multiline: true }),
    openGraph: object("Open graph", {
      fields: type("Open graph fields", {
        title: text("Title", { width: 0.5 }),
        image: link.image("Image", { width: 0.5 }),
        description: text("Description", { multiline: true })
      })
    })
  });
  return new MetadataField(Type.shape(fields), {
    hint: Type.hint(fields),
    options: { label, ...options, fields }
  });
}
export {
  MetadataField,
  metadata
};
