import "../../chunks/chunk-U5RRZUYZ.js";

// src/input/number/NumberField.browser.tsx
import { Field } from "alinea/core";
import { useField } from "alinea/dashboard/editor/UseField";
import { InputLabel } from "alinea/dashboard/view/InputLabel";
import { fromModule } from "alinea/ui";
import { IcRoundNumbers } from "alinea/ui/icons/IcRoundNumbers";
import { useEffect, useRef } from "react";
import { number as createNumber } from "./NumberField.js";

// src/input/number/NumberInput.module.scss
var NumberInput_module_default = {
  "root-input": "alinea-NumberInput-input",
  "rootInput": "alinea-NumberInput-input"
};

// src/input/number/NumberField.browser.tsx
export * from "./NumberField.js";
import { jsx } from "react/jsx-runtime";
var number = Field.provideView(NumberInput, createNumber);
var styles = fromModule(NumberInput_module_default);
function tryParseNumber(input) {
  const value = parseFloat(input);
  return isNaN(value) ? null : value;
}
function NumberInput({ field }) {
  const { options, value, mutator } = useField(field);
  const { minValue, maxValue, readOnly, step } = options;
  const ref = useRef(null);
  const defaultValue = String(value ?? "");
  useEffect(() => {
    const input = ref.current;
    if (!input)
      return;
    const currentInput = tryParseNumber(input.value);
    if (currentInput === value)
      return;
    input.value = defaultValue;
  }, [defaultValue]);
  return /* @__PURE__ */ jsx(InputLabel, { asLabel: true, ...options, icon: IcRoundNumbers, children: /* @__PURE__ */ jsx(
    "input",
    {
      type: "number",
      ref,
      className: styles.root.input(),
      defaultValue,
      onChange: ({ currentTarget }) => {
        const value2 = tryParseNumber(currentTarget.value);
        mutator(value2);
      },
      onBlur: ({ currentTarget }) => {
        const value2 = tryParseNumber(currentTarget.value);
        mutator(value2);
        currentTarget.value = String(value2 ?? "");
      },
      min: minValue,
      max: maxValue,
      disabled: readOnly,
      step: step || 1
    }
  ) });
}
export {
  number
};
