import { Reference } from 'alinea/core/Reference';
export interface EntryLinkReference extends Reference {
    entry: string;
}
export interface EntryReference extends EntryLinkReference {
    title: string;
    entryType: string;
    path: string;
    url: string;
}
export declare namespace EntryReference {
    function isEntryReference(value: any): value is EntryReference;
}
export interface FileReference extends EntryLinkReference {
    title: string;
    src: string;
    url: string;
    extension: string;
    size: number;
}
export declare namespace FileReference {
    function isFileReference(value: any): value is FileReference;
}
export interface ImageReference extends EntryLinkReference {
    title: string;
    src: string;
    extension: string;
    size: number;
    hash: string;
    width: number;
    height: number;
    averageColor: string;
    thumbHash: string;
    focus: {
        x: number;
        y: number;
    };
}
export declare namespace ImageReference {
    function isImageReference(value: any): value is ImageReference;
}
